
import Globals, OFS, os
from Globals import DTMLFile
from OFS.ObjectManager import ObjectManager
from App.ApplicationManager import ApplicationManager
from Acquisition import aq_base

import SuperLogger

def installControlPanel(context, panelClass):
    app = context._ProductContext__app
    cp = app.Control_Panel
    id = panelClass.id
    if 0: # Enable to clean up the control panel.
        try: del cp._objects
        except: pass
    cp.id # Unghostify.
    existing = getattr(aq_base(cp), id, None)
    if existing is None or existing.__class__ != panelClass:
        cp._setObject(id, panelClass())
    return cp._getOb(id)

_prodname = __name__.split('.')[-1]

def createIcon(iconspec, _prefix, pid=_prodname):
    name = os.path.split(iconspec)[1]
    res = 'misc_/%s/%s' % (pid, name)
    icon = Globals.ImageFile(iconspec, _prefix)
    icon.__roles__=None
    if not hasattr(OFS.misc_.misc_, pid):
        setattr(OFS.misc_.misc_, pid, OFS.misc_.Misc_(pid, {}))
    getattr(OFS.misc_.misc_, pid)[name]=icon
    return res

def initialize(context):
    installControlPanel(context, SuperLogger.SuperLogger)
    SuperLogger.SuperLogger.icon = createIcon('www/logger.gif', globals())
